// ColorPAL
// Chin-Shiuh Shieh on 2014-12-07

#define ColorPAL_Sig A4

void ColorPAL_reset(void){
  pinMode(ColorPAL_Sig,OUTPUT);digitalWrite(ColorPAL_Sig,LOW);
  pinMode(ColorPAL_Sig,INPUT);digitalWrite(ColorPAL_Sig,HIGH);
  while(digitalRead(ColorPAL_Sig)==LOW);
  pinMode(ColorPAL_Sig,OUTPUT);digitalWrite(ColorPAL_Sig,LOW);delay(80);
  pinMode(ColorPAL_Sig,INPUT);digitalWrite(ColorPAL_Sig,HIGH);delay(10);
}

void shift_out(unsigned char data){
  unsigned char i;
  pinMode(ColorPAL_Sig,OUTPUT);
  digitalWrite(ColorPAL_Sig,LOW);delayMicroseconds(208);
  for(i=0;i<8;i++){
    if(data%2==1)digitalWrite(ColorPAL_Sig,HIGH);else digitalWrite(ColorPAL_Sig,LOW);data>>=1;
    delayMicroseconds(208);
  }
  digitalWrite(ColorPAL_Sig,HIGH);delayMicroseconds(208);
}

unsigned char shift_in(void){
  unsigned char i,data=0;
  pinMode(ColorPAL_Sig,INPUT);digitalWrite(ColorPAL_Sig,HIGH);
  while(digitalRead(ColorPAL_Sig)==HIGH);
  delayMicroseconds(208);
  for(i=0;i<8;i++){
    delayMicroseconds(104);
    data>>=1;if(digitalRead(ColorPAL_Sig)==HIGH)data+=128;
    delayMicroseconds(104);
  }
  delayMicroseconds(208);
  return data;
}

void setup(void){
  Serial.begin(9600);
}

void loop(void){
  shift_out('=');shift_out('R');shift_out('!');delay(500);
  shift_out('=');shift_out('G');shift_out('!');delay(500);
  shift_out('=');shift_out('B');shift_out('!');delay(500);
  while(1){
    shift_out('=');shift_out('m');shift_out('!');
    Serial.write(shift_in());Serial.write(shift_in());Serial.write(shift_in());Serial.print(" ");
    Serial.write(shift_in());Serial.write(shift_in());Serial.write(shift_in());Serial.print(" ");
    Serial.write(shift_in());Serial.write(shift_in());Serial.write(shift_in());Serial.println("");
    delay(1000);
  }
}
